import sys
from numpy import *
import os

def getRawDataByTOD(rawDataFilename):
    nightdata = [];
    daydata = [];
    lastrow = None;
    lastsecs = None;
    isNewPeriod = False;
    isFirstRecord = True;
    sample = 0;
    maxseconds = 16777216;
    with open(rawDataFilename) as f:
        for line in f:
            sample += 1;
            items = line.split(',');
            month = int(items[1]);
            day = int(items[2]);
            hour = int(items[3])
            dayseconds = hour * 3600 + int(items[4]) * 60 + int(items[5]);
            if hour >=23 or hour < 7:
                if not isFirstRecord and isDayTime:
                    isNewPeriod = True;
                isDayTime = False;
            else:
                if not isFirstRecord and not isDayTime:
                    isNewPeriod = True;
                isDayTime = True;


            asecs = int(items[9]);
            row = [int(x) for x in items[11:]];
            if isFirstRecord or isNewPeriod:
                lastrow = row;
                lastsecs = asecs;
                isFirstRecord = False;
                isNewPeriod = False
            else:
                # Try to detect seconds counter wrap
                if asecs < lastsecs:
                    if (maxseconds - lastsecs) < 60:
                        print('Possible seconds counter wrap');

                diffsecs = asecs - lastsecs;
                watts = [float(month),float(day),float(dayseconds),float(asecs),float(diffsecs)];
                watts = watts + [(a - b) / watts[4] for a,b in zip(row,lastrow)];
                if diffsecs <= 0:
                    print('Ignoring sample %d due to time warp' % sample);
                    print(watts);
                else:
                    if isDayTime:
                        daydata.append(watts);
                    else:
                        nightdata.append(watts);

                    lastrow = row;
                    lastsecs = asecs;

        f.close();
        print('Highest seconds counter value: %d' % lastsecs);
        return daydata, nightdata;

if len(sys.argv) != 2:
    print('Usage: %s <raw data file name>' % sys.argv[0]);
    sys.exit(1);
else:
    # Convert raw data to numpy matrix having Watts for Mains and
    # Individual Circuits per row 
    day, night = getRawDataByTOD(sys.argv[1]);
    fname = '%sDaytime.npy' % os.path.splitext(sys.argv[1])[0];
    print('Data extracted to %s' % fname);
    save(fname,array(day));
    fname = '%sNighttime.npy' % os.path.splitext(sys.argv[1])[0];
    print('Data extracted to %s' % fname);
    save(fname,array(night));
    print('Daytime = [7AM,11PM) = 16 Hours and Nightime = [11PM,7AM) = 8 Hours');

    sys.exit(0);

          

