import sys
from numpy import *
import matplotlib.pyplot as plt
import os

if len(sys.argv) != 4:
    print('Usage: %s <watts data file name> <when> <print-only>' % sys.argv[0]);
    sys.exit(1);
else:
    # Load the data
    data = load(sys.argv[1]);
    intervals = data[:,4];

    # plot intervals
    plt.plot(range(len(intervals)),intervals,'bo');
    plt.title('GreenEye Sample Intervals\n%s Data Set' % sys.argv[2]);
    plt.xlabel('Interval Index');
    plt.ylabel('Interval Duration (s)');
    plt.savefig('%sTimeBetweenSamples.png' % os.path.splitext(sys.argv[1])[0].replace('Data','Figures'),format='png',bbox_inches='tight');

    # Print only?
    if int(sys.argv[3]) == 0:
        plt.show();

    sys.exit(0);

          

