from numpy import *
import calendar
import sys
from os import *


if len(sys.argv) != 2:
    print('Usage: %s <csv-data-file>' % sys.argv[0]);
    sys.exit(1);


recarr = genfromtxt(sys.argv[1],delimiter=',',dtype=None);

data = array(recarr.tolist());

cal = calendar.Calendar();
daysoftheweek = [calendar.day_name[day] for day in cal.iterweekdays()]

averages = zeros((len(daysoftheweek),24));
sigmas = zeros((len(daysoftheweek),24));

row = 0;
for day in daysoftheweek:
    daydata = data[where(data[:,2]==day),3:].astype(float)[0];
    for column in range(daydata.shape[1]):
        averages[row,column] = daydata[where(daydata[:,column]>=0),column].mean();
        sigmas[row,column] = daydata[where(daydata[:,column]>=0),column].std();
    row += 1;


save('%s_averages.npy' % path.splitext(sys.argv[1])[0],averages);
save('%s_sigmas.npy' % path.splitext(sys.argv[1])[0],sigmas);





